<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>javascript-cheatsheet</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <p>
      JavaScript was created by Netscape’s Brendan Eich in 1995. It was
      originally intended as a simpler scripting language for websites,
      complementing the use of Java for more complex web applications, but its
      tight integration with Web pages and built-in support in browsers has
      caused it to become far more common than Java in web frontends.
    </p>
    <p>
      JavaScript isn’t just limited to web browsers, though: Node.js, a project
      that provides a standalone runtime for Google Chrome’s V8 JavaScript
      engine, is becoming more and more popular.
    </p>
    <p>
      JavaScript has a C-like syntax, so if you’ve used languages like C or
      Java, a lot of the basic syntax will already be familiar. Despite this,
      and despite the similarity in name, JavaScript’s object model is
      significantly different to Java’s.
    </p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="co">// Single-line comments start with two slashes.</span></a>
<a class="sourceLine" id="cb1-2" title="2"><span class="co">/* Multiline comments start with slash-star,</span></a>
<a class="sourceLine" id="cb1-3" title="3"><span class="co">   and end with star-slash */</span></a>
<a class="sourceLine" id="cb1-4" title="4"></a>
<a class="sourceLine" id="cb1-5" title="5"><span class="co">// Statements can be terminated by ;</span></a>
<a class="sourceLine" id="cb1-6" title="6"><span class="at">doStuff</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb1-7" title="7"></a>
<a class="sourceLine" id="cb1-8" title="8"><span class="co">// ... but they don&#39;t have to be, as semicolons are automatically inserted</span></a>
<a class="sourceLine" id="cb1-9" title="9"><span class="co">// wherever there&#39;s a newline, except in certain cases.</span></a>
<a class="sourceLine" id="cb1-10" title="10"><span class="at">doStuff</span>()</a>
<a class="sourceLine" id="cb1-11" title="11"></a>
<a class="sourceLine" id="cb1-12" title="12"><span class="co">// Because those cases can cause unexpected results, we&#39;ll keep on using</span></a>
<a class="sourceLine" id="cb1-13" title="13"><span class="co">// semicolons in this guide.</span></a>
<a class="sourceLine" id="cb1-14" title="14"></a>
<a class="sourceLine" id="cb1-15" title="15"><span class="co">///////////////////////////////////</span></a>
<a class="sourceLine" id="cb1-16" title="16"><span class="co">// 1. Numbers, Strings and Operators</span></a>
<a class="sourceLine" id="cb1-17" title="17"></a>
<a class="sourceLine" id="cb1-18" title="18"><span class="co">// JavaScript has one number type (which is a 64-bit IEEE 754 double).</span></a>
<a class="sourceLine" id="cb1-19" title="19"><span class="co">// Doubles have a 52-bit mantissa, which is enough to store integers</span></a>
<a class="sourceLine" id="cb1-20" title="20"><span class="co">// up to about 9✕10¹⁵ precisely.</span></a>
<a class="sourceLine" id="cb1-21" title="21"><span class="dv">3</span><span class="op">;</span> <span class="co">// = 3</span></a>
<a class="sourceLine" id="cb1-22" title="22"><span class="fl">1.5</span><span class="op">;</span> <span class="co">// = 1.5</span></a>
<a class="sourceLine" id="cb1-23" title="23"></a>
<a class="sourceLine" id="cb1-24" title="24"><span class="co">// Some basic arithmetic works as you&#39;d expect.</span></a>
<a class="sourceLine" id="cb1-25" title="25"><span class="dv">1</span> <span class="op">+</span> <span class="dv">1</span><span class="op">;</span> <span class="co">// = 2</span></a>
<a class="sourceLine" id="cb1-26" title="26"><span class="fl">0.1</span> <span class="op">+</span> <span class="fl">0.2</span><span class="op">;</span> <span class="co">// = 0.30000000000000004</span></a>
<a class="sourceLine" id="cb1-27" title="27"><span class="dv">8</span> <span class="op">-</span> <span class="dv">1</span><span class="op">;</span> <span class="co">// = 7</span></a>
<a class="sourceLine" id="cb1-28" title="28"><span class="dv">10</span> <span class="op">*</span> <span class="dv">2</span><span class="op">;</span> <span class="co">// = 20</span></a>
<a class="sourceLine" id="cb1-29" title="29"><span class="dv">35</span> / <span class="dv">5</span><span class="op">;</span> <span class="co">// = 7</span></a>
<a class="sourceLine" id="cb1-30" title="30"></a>
<a class="sourceLine" id="cb1-31" title="31"><span class="co">// Including uneven division.</span></a>
<a class="sourceLine" id="cb1-32" title="32"><span class="dv">5</span> / <span class="dv">2</span><span class="op">;</span> <span class="co">// = 2.5</span></a>
<a class="sourceLine" id="cb1-33" title="33"></a>
<a class="sourceLine" id="cb1-34" title="34"><span class="co">// And modulo division.</span></a>
<a class="sourceLine" id="cb1-35" title="35"><span class="dv">10</span> <span class="op">%</span> <span class="dv">2</span><span class="op">;</span> <span class="co">// = 0</span></a>
<a class="sourceLine" id="cb1-36" title="36"><span class="dv">30</span> <span class="op">%</span> <span class="dv">4</span><span class="op">;</span> <span class="co">// = 2</span></a>
<a class="sourceLine" id="cb1-37" title="37"><span class="fl">18.5</span> <span class="op">%</span> <span class="dv">7</span><span class="op">;</span> <span class="co">// = 4.5</span></a>
<a class="sourceLine" id="cb1-38" title="38"></a>
<a class="sourceLine" id="cb1-39" title="39"><span class="co">// Bitwise operations also work; when you perform a bitwise operation your float</span></a>
<a class="sourceLine" id="cb1-40" title="40"><span class="co">// is converted to a signed int *up to* 32 bits.</span></a>
<a class="sourceLine" id="cb1-41" title="41"><span class="dv">1</span> <span class="op">&lt;&lt;</span> <span class="dv">2</span><span class="op">;</span> <span class="co">// = 4</span></a>
<a class="sourceLine" id="cb1-42" title="42"></a>
<a class="sourceLine" id="cb1-43" title="43"><span class="co">// Precedence is enforced with parentheses.</span></a>
<a class="sourceLine" id="cb1-44" title="44">(<span class="dv">1</span> <span class="op">+</span> <span class="dv">3</span>) <span class="op">*</span> <span class="dv">2</span><span class="op">;</span> <span class="co">// = 8</span></a>
<a class="sourceLine" id="cb1-45" title="45"></a>
<a class="sourceLine" id="cb1-46" title="46"><span class="co">// There are three special not-a-real-number values:</span></a>
<a class="sourceLine" id="cb1-47" title="47"><span class="kw">Infinity</span><span class="op">;</span> <span class="co">// result of e.g. 1/0</span></a>
<a class="sourceLine" id="cb1-48" title="48"><span class="op">-</span><span class="kw">Infinity</span><span class="op">;</span> <span class="co">// result of e.g. -1/0</span></a>
<a class="sourceLine" id="cb1-49" title="49"><span class="kw">NaN</span><span class="op">;</span> <span class="co">// result of e.g. 0/0, stands for &#39;Not a Number&#39;</span></a>
<a class="sourceLine" id="cb1-50" title="50"></a>
<a class="sourceLine" id="cb1-51" title="51"><span class="co">// There&#39;s also a boolean type.</span></a>
<a class="sourceLine" id="cb1-52" title="52"><span class="kw">true</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-53" title="53"><span class="kw">false</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-54" title="54"></a>
<a class="sourceLine" id="cb1-55" title="55"><span class="co">// Strings are created with &#39; or &quot;.</span></a>
<a class="sourceLine" id="cb1-56" title="56"><span class="st">&#39;abc&#39;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-57" title="57"><span class="st">&quot;Hello, world&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-58" title="58"></a>
<a class="sourceLine" id="cb1-59" title="59"><span class="co">// Negation uses the ! symbol</span></a>
<a class="sourceLine" id="cb1-60" title="60"><span class="op">!</span><span class="kw">true</span><span class="op">;</span> <span class="co">// = false</span></a>
<a class="sourceLine" id="cb1-61" title="61"><span class="op">!</span><span class="kw">false</span><span class="op">;</span> <span class="co">// = true</span></a>
<a class="sourceLine" id="cb1-62" title="62"></a>
<a class="sourceLine" id="cb1-63" title="63"><span class="co">// Equality is ===</span></a>
<a class="sourceLine" id="cb1-64" title="64"><span class="dv">1</span> <span class="op">===</span> <span class="dv">1</span><span class="op">;</span> <span class="co">// = true</span></a>
<a class="sourceLine" id="cb1-65" title="65"><span class="dv">2</span> <span class="op">===</span> <span class="dv">1</span><span class="op">;</span> <span class="co">// = false</span></a>
<a class="sourceLine" id="cb1-66" title="66"></a>
<a class="sourceLine" id="cb1-67" title="67"><span class="co">// Inequality is !==</span></a>
<a class="sourceLine" id="cb1-68" title="68"><span class="dv">1</span> <span class="op">!==</span> <span class="dv">1</span><span class="op">;</span> <span class="co">// = false</span></a>
<a class="sourceLine" id="cb1-69" title="69"><span class="dv">2</span> <span class="op">!==</span> <span class="dv">1</span><span class="op">;</span> <span class="co">// = true</span></a>
<a class="sourceLine" id="cb1-70" title="70"></a>
<a class="sourceLine" id="cb1-71" title="71"><span class="co">// More comparisons</span></a>
<a class="sourceLine" id="cb1-72" title="72"><span class="dv">1</span> <span class="op">&lt;</span> <span class="dv">10</span><span class="op">;</span> <span class="co">// = true</span></a>
<a class="sourceLine" id="cb1-73" title="73"><span class="dv">1</span> <span class="op">&gt;</span> <span class="dv">10</span><span class="op">;</span> <span class="co">// = false</span></a>
<a class="sourceLine" id="cb1-74" title="74"><span class="dv">2</span> <span class="op">&lt;=</span> <span class="dv">2</span><span class="op">;</span> <span class="co">// = true</span></a>
<a class="sourceLine" id="cb1-75" title="75"><span class="dv">2</span> <span class="op">&gt;=</span> <span class="dv">2</span><span class="op">;</span> <span class="co">// = true</span></a>
<a class="sourceLine" id="cb1-76" title="76"></a>
<a class="sourceLine" id="cb1-77" title="77"><span class="co">// Strings are concatenated with +</span></a>
<a class="sourceLine" id="cb1-78" title="78"><span class="st">&quot;Hello &quot;</span> <span class="op">+</span> <span class="st">&quot;world!&quot;</span><span class="op">;</span> <span class="co">// = &quot;Hello world!&quot;</span></a>
<a class="sourceLine" id="cb1-79" title="79"></a>
<a class="sourceLine" id="cb1-80" title="80"><span class="co">// ... which works with more than just strings</span></a>
<a class="sourceLine" id="cb1-81" title="81"><span class="st">&quot;1, 2, &quot;</span> <span class="op">+</span> <span class="dv">3</span><span class="op">;</span> <span class="co">// = &quot;1, 2, 3&quot;</span></a>
<a class="sourceLine" id="cb1-82" title="82"><span class="st">&quot;Hello &quot;</span> <span class="op">+</span> [<span class="st">&quot;world&quot;</span><span class="op">,</span> <span class="st">&quot;!&quot;</span>]<span class="op">;</span> <span class="co">// = &quot;Hello world,!&quot;</span></a>
<a class="sourceLine" id="cb1-83" title="83"></a>
<a class="sourceLine" id="cb1-84" title="84"><span class="co">// and are compared with &lt; and &gt;</span></a>
<a class="sourceLine" id="cb1-85" title="85"><span class="st">&quot;a&quot;</span> <span class="op">&lt;</span> <span class="st">&quot;b&quot;</span><span class="op">;</span> <span class="co">// = true</span></a>
<a class="sourceLine" id="cb1-86" title="86"></a>
<a class="sourceLine" id="cb1-87" title="87"><span class="co">// Type coercion is performed for comparisons with double equals...</span></a>
<a class="sourceLine" id="cb1-88" title="88"><span class="st">&quot;5&quot;</span> <span class="op">==</span> <span class="dv">5</span><span class="op">;</span> <span class="co">// = true</span></a>
<a class="sourceLine" id="cb1-89" title="89"><span class="kw">null</span> <span class="op">==</span> <span class="kw">undefined</span><span class="op">;</span> <span class="co">// = true</span></a>
<a class="sourceLine" id="cb1-90" title="90"></a>
<a class="sourceLine" id="cb1-91" title="91"><span class="co">// ...unless you use ===</span></a>
<a class="sourceLine" id="cb1-92" title="92"><span class="st">&quot;5&quot;</span> <span class="op">===</span> <span class="dv">5</span><span class="op">;</span> <span class="co">// = false</span></a>
<a class="sourceLine" id="cb1-93" title="93"><span class="kw">null</span> <span class="op">===</span> <span class="kw">undefined</span><span class="op">;</span> <span class="co">// = false</span></a>
<a class="sourceLine" id="cb1-94" title="94"></a>
<a class="sourceLine" id="cb1-95" title="95"><span class="co">// ...which can result in some weird behaviour...</span></a>
<a class="sourceLine" id="cb1-96" title="96"><span class="dv">13</span> <span class="op">+</span> <span class="op">!</span><span class="dv">0</span><span class="op">;</span> <span class="co">// 14</span></a>
<a class="sourceLine" id="cb1-97" title="97"><span class="st">&quot;13&quot;</span> <span class="op">+</span> <span class="op">!</span><span class="dv">0</span><span class="op">;</span> <span class="co">// &#39;13true&#39;</span></a>
<a class="sourceLine" id="cb1-98" title="98"></a>
<a class="sourceLine" id="cb1-99" title="99"><span class="co">// You can access characters in a string with `charAt`</span></a>
<a class="sourceLine" id="cb1-100" title="100"><span class="st">&quot;This is a string&quot;</span>.<span class="at">charAt</span>(<span class="dv">0</span>)<span class="op">;</span>  <span class="co">// = &#39;T&#39;</span></a>
<a class="sourceLine" id="cb1-101" title="101"></a>
<a class="sourceLine" id="cb1-102" title="102"><span class="co">// ...or use `substring` to get larger pieces.</span></a>
<a class="sourceLine" id="cb1-103" title="103"><span class="st">&quot;Hello world&quot;</span>.<span class="at">substring</span>(<span class="dv">0</span><span class="op">,</span> <span class="dv">5</span>)<span class="op">;</span> <span class="co">// = &quot;Hello&quot;</span></a>
<a class="sourceLine" id="cb1-104" title="104"></a>
<a class="sourceLine" id="cb1-105" title="105"><span class="co">// `length` is a property, so don&#39;t use ().</span></a>
<a class="sourceLine" id="cb1-106" title="106"><span class="st">&quot;Hello&quot;</span>.<span class="at">length</span><span class="op">;</span> <span class="co">// = 5</span></a>
<a class="sourceLine" id="cb1-107" title="107"></a>
<a class="sourceLine" id="cb1-108" title="108"><span class="co">// There&#39;s also `null` and `undefined`.</span></a>
<a class="sourceLine" id="cb1-109" title="109"><span class="kw">null</span><span class="op">;</span>      <span class="co">// used to indicate a deliberate non-value</span></a>
<a class="sourceLine" id="cb1-110" title="110"><span class="kw">undefined</span><span class="op">;</span> <span class="co">// used to indicate a value is not currently present (although</span></a>
<a class="sourceLine" id="cb1-111" title="111">           <span class="co">// `undefined` is actually a value itself)</span></a>
<a class="sourceLine" id="cb1-112" title="112"></a>
<a class="sourceLine" id="cb1-113" title="113"><span class="co">// false, null, undefined, NaN, 0 and &quot;&quot; are falsy; everything else is truthy.</span></a>
<a class="sourceLine" id="cb1-114" title="114"><span class="co">// Note that 0 is falsy and &quot;0&quot; is truthy, even though 0 == &quot;0&quot;.</span></a>
<a class="sourceLine" id="cb1-115" title="115"></a>
<a class="sourceLine" id="cb1-116" title="116"><span class="co">///////////////////////////////////</span></a>
<a class="sourceLine" id="cb1-117" title="117"><span class="co">// 2. Variables, Arrays and Objects</span></a>
<a class="sourceLine" id="cb1-118" title="118"></a>
<a class="sourceLine" id="cb1-119" title="119"><span class="co">// Variables are declared with the `var` keyword. JavaScript is dynamically</span></a>
<a class="sourceLine" id="cb1-120" title="120"><span class="co">// typed, so you don&#39;t need to specify type. Assignment uses a single `=`</span></a>
<a class="sourceLine" id="cb1-121" title="121"><span class="co">// character.</span></a>
<a class="sourceLine" id="cb1-122" title="122"><span class="kw">var</span> someVar <span class="op">=</span> <span class="dv">5</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-123" title="123"></a>
<a class="sourceLine" id="cb1-124" title="124"><span class="co">// If you leave the var keyword off, you won&#39;t get an error...</span></a>
<a class="sourceLine" id="cb1-125" title="125">someOtherVar <span class="op">=</span> <span class="dv">10</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-126" title="126"></a>
<a class="sourceLine" id="cb1-127" title="127"><span class="co">// ...but your variable will be created in the global scope, not in the scope</span></a>
<a class="sourceLine" id="cb1-128" title="128"><span class="co">// you defined it in.</span></a>
<a class="sourceLine" id="cb1-129" title="129"></a>
<a class="sourceLine" id="cb1-130" title="130"><span class="co">// Variables declared without being assigned to are set to undefined.</span></a>
<a class="sourceLine" id="cb1-131" title="131"><span class="kw">var</span> someThirdVar<span class="op">;</span> <span class="co">// = undefined</span></a>
<a class="sourceLine" id="cb1-132" title="132"></a>
<a class="sourceLine" id="cb1-133" title="133"><span class="co">// If you want to declare a couple of variables, then you could use a comma</span></a>
<a class="sourceLine" id="cb1-134" title="134"><span class="co">// separator</span></a>
<a class="sourceLine" id="cb1-135" title="135"><span class="kw">var</span> someFourthVar <span class="op">=</span> <span class="dv">2</span><span class="op">,</span> someFifthVar <span class="op">=</span> <span class="dv">4</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-136" title="136"></a>
<a class="sourceLine" id="cb1-137" title="137"><span class="co">// There&#39;s shorthand for performing math operations on variables:</span></a>
<a class="sourceLine" id="cb1-138" title="138">someVar <span class="op">+=</span> <span class="dv">5</span><span class="op">;</span> <span class="co">// equivalent to someVar = someVar + 5; someVar is 10 now</span></a>
<a class="sourceLine" id="cb1-139" title="139">someVar <span class="op">*=</span> <span class="dv">10</span><span class="op">;</span> <span class="co">// now someVar is 100</span></a>
<a class="sourceLine" id="cb1-140" title="140"></a>
<a class="sourceLine" id="cb1-141" title="141"><span class="co">// and an even-shorter-hand for adding or subtracting 1</span></a>
<a class="sourceLine" id="cb1-142" title="142">someVar<span class="op">++;</span> <span class="co">// now someVar is 101</span></a>
<a class="sourceLine" id="cb1-143" title="143">someVar<span class="op">--;</span> <span class="co">// back to 100</span></a>
<a class="sourceLine" id="cb1-144" title="144"></a>
<a class="sourceLine" id="cb1-145" title="145"><span class="co">// Arrays are ordered lists of values, of any type.</span></a>
<a class="sourceLine" id="cb1-146" title="146"><span class="kw">var</span> myArray <span class="op">=</span> [<span class="st">&quot;Hello&quot;</span><span class="op">,</span> <span class="dv">45</span><span class="op">,</span> <span class="kw">true</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb1-147" title="147"></a>
<a class="sourceLine" id="cb1-148" title="148"><span class="co">// Their members can be accessed using the square-brackets subscript syntax.</span></a>
<a class="sourceLine" id="cb1-149" title="149"><span class="co">// Array indices start at zero.</span></a>
<a class="sourceLine" id="cb1-150" title="150">myArray[<span class="dv">1</span>]<span class="op">;</span> <span class="co">// = 45</span></a>
<a class="sourceLine" id="cb1-151" title="151"></a>
<a class="sourceLine" id="cb1-152" title="152"><span class="co">// Arrays are mutable and of variable length.</span></a>
<a class="sourceLine" id="cb1-153" title="153"><span class="va">myArray</span>.<span class="at">push</span>(<span class="st">&quot;World&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-154" title="154"><span class="va">myArray</span>.<span class="at">length</span><span class="op">;</span> <span class="co">// = 4</span></a>
<a class="sourceLine" id="cb1-155" title="155"></a>
<a class="sourceLine" id="cb1-156" title="156"><span class="co">// Add/Modify at specific index</span></a>
<a class="sourceLine" id="cb1-157" title="157">myArray[<span class="dv">3</span>] <span class="op">=</span> <span class="st">&quot;Hello&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-158" title="158"></a>
<a class="sourceLine" id="cb1-159" title="159"><span class="co">// Add and remove element from front or back end of an array</span></a>
<a class="sourceLine" id="cb1-160" title="160"><span class="va">myArray</span>.<span class="at">unshift</span>(<span class="dv">3</span>)<span class="op">;</span> <span class="co">// Add as the first element</span></a>
<a class="sourceLine" id="cb1-161" title="161">someVar <span class="op">=</span> <span class="va">myArray</span>.<span class="at">shift</span>()<span class="op">;</span> <span class="co">// Remove first element and return it</span></a>
<a class="sourceLine" id="cb1-162" title="162"><span class="va">myArray</span>.<span class="at">push</span>(<span class="dv">3</span>)<span class="op">;</span> <span class="co">// Add as the last element</span></a>
<a class="sourceLine" id="cb1-163" title="163">someVar <span class="op">=</span> <span class="va">myArray</span>.<span class="at">pop</span>()<span class="op">;</span> <span class="co">// Remove last element and return it</span></a>
<a class="sourceLine" id="cb1-164" title="164"></a>
<a class="sourceLine" id="cb1-165" title="165"><span class="co">// Join all elements of an array with semicolon</span></a>
<a class="sourceLine" id="cb1-166" title="166"><span class="kw">var</span> myArray0 <span class="op">=</span> [<span class="dv">32</span><span class="op">,</span><span class="kw">false</span><span class="op">,</span><span class="st">&quot;js&quot;</span><span class="op">,</span><span class="dv">12</span><span class="op">,</span><span class="dv">56</span><span class="op">,</span><span class="dv">90</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb1-167" title="167"><span class="va">myArray0</span>.<span class="at">join</span>(<span class="st">&quot;;&quot;</span>)<span class="op">;</span> <span class="co">// = &quot;32;false;js;12;56;90&quot;</span></a>
<a class="sourceLine" id="cb1-168" title="168"></a>
<a class="sourceLine" id="cb1-169" title="169"><span class="co">// Get subarray of elements from index 1 (include) to 4 (exclude)</span></a>
<a class="sourceLine" id="cb1-170" title="170"><span class="va">myArray0</span>.<span class="at">slice</span>(<span class="dv">1</span><span class="op">,</span><span class="dv">4</span>)<span class="op">;</span> <span class="co">// = [false,&quot;js&quot;,12]</span></a>
<a class="sourceLine" id="cb1-171" title="171"></a>
<a class="sourceLine" id="cb1-172" title="172"><span class="co">// Remove 4 elements starting from index 2, and insert there strings</span></a>
<a class="sourceLine" id="cb1-173" title="173"><span class="co">// &quot;hi&quot;,&quot;wr&quot; and &quot;ld&quot;; return removed subarray</span></a>
<a class="sourceLine" id="cb1-174" title="174"><span class="va">myArray0</span>.<span class="at">splice</span>(<span class="dv">2</span><span class="op">,</span><span class="dv">4</span><span class="op">,</span><span class="st">&quot;hi&quot;</span><span class="op">,</span><span class="st">&quot;wr&quot;</span><span class="op">,</span><span class="st">&quot;ld&quot;</span>)<span class="op">;</span> <span class="co">// = [&quot;js&quot;,12,56,90]</span></a>
<a class="sourceLine" id="cb1-175" title="175"><span class="co">// myArray0 === [32,false,&quot;hi&quot;,&quot;wr&quot;,&quot;ld&quot;]</span></a>
<a class="sourceLine" id="cb1-176" title="176"></a>
<a class="sourceLine" id="cb1-177" title="177"><span class="co">// JavaScript&#39;s objects are equivalent to &quot;dictionaries&quot; or &quot;maps&quot; in other</span></a>
<a class="sourceLine" id="cb1-178" title="178"><span class="co">// languages: an unordered collection of key-value pairs.</span></a>
<a class="sourceLine" id="cb1-179" title="179"><span class="kw">var</span> myObj <span class="op">=</span> <span class="op">{</span><span class="dt">key1</span><span class="op">:</span> <span class="st">&quot;Hello&quot;</span><span class="op">,</span> <span class="dt">key2</span><span class="op">:</span> <span class="st">&quot;World&quot;</span><span class="op">};</span></a>
<a class="sourceLine" id="cb1-180" title="180"></a>
<a class="sourceLine" id="cb1-181" title="181"><span class="co">// Keys are strings, but quotes aren&#39;t required if they&#39;re a valid</span></a>
<a class="sourceLine" id="cb1-182" title="182"><span class="co">// JavaScript identifier. Values can be any type.</span></a>
<a class="sourceLine" id="cb1-183" title="183"><span class="kw">var</span> myObj <span class="op">=</span> <span class="op">{</span><span class="dt">myKey</span><span class="op">:</span> <span class="st">&quot;myValue&quot;</span><span class="op">,</span> <span class="st">&quot;my other key&quot;</span><span class="op">:</span> <span class="dv">4</span><span class="op">};</span></a>
<a class="sourceLine" id="cb1-184" title="184"></a>
<a class="sourceLine" id="cb1-185" title="185"><span class="co">// Object attributes can also be accessed using the subscript syntax,</span></a>
<a class="sourceLine" id="cb1-186" title="186">myObj[<span class="st">&quot;my other key&quot;</span>]<span class="op">;</span> <span class="co">// = 4</span></a>
<a class="sourceLine" id="cb1-187" title="187"></a>
<a class="sourceLine" id="cb1-188" title="188"><span class="co">// ... or using the dot syntax, provided the key is a valid identifier.</span></a>
<a class="sourceLine" id="cb1-189" title="189"><span class="va">myObj</span>.<span class="at">myKey</span><span class="op">;</span> <span class="co">// = &quot;myValue&quot;</span></a>
<a class="sourceLine" id="cb1-190" title="190"></a>
<a class="sourceLine" id="cb1-191" title="191"><span class="co">// Objects are mutable; values can be changed and new keys added.</span></a>
<a class="sourceLine" id="cb1-192" title="192"><span class="va">myObj</span>.<span class="at">myThirdKey</span> <span class="op">=</span> <span class="kw">true</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-193" title="193"></a>
<a class="sourceLine" id="cb1-194" title="194"><span class="co">// If you try to access a value that&#39;s not yet set, you&#39;ll get undefined.</span></a>
<a class="sourceLine" id="cb1-195" title="195"><span class="va">myObj</span>.<span class="at">myFourthKey</span><span class="op">;</span> <span class="co">// = undefined</span></a>
<a class="sourceLine" id="cb1-196" title="196"></a>
<a class="sourceLine" id="cb1-197" title="197"><span class="co">///////////////////////////////////</span></a>
<a class="sourceLine" id="cb1-198" title="198"><span class="co">// 3. Logic and Control Structures</span></a>
<a class="sourceLine" id="cb1-199" title="199"></a>
<a class="sourceLine" id="cb1-200" title="200"><span class="co">// The `if` structure works as you&#39;d expect.</span></a>
<a class="sourceLine" id="cb1-201" title="201"><span class="kw">var</span> count <span class="op">=</span> <span class="dv">1</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-202" title="202"><span class="cf">if</span> (count <span class="op">==</span> <span class="dv">3</span>)<span class="op">{</span></a>
<a class="sourceLine" id="cb1-203" title="203">    <span class="co">// evaluated if count is 3</span></a>
<a class="sourceLine" id="cb1-204" title="204"><span class="op">}</span> <span class="cf">else</span> <span class="cf">if</span> (count <span class="op">==</span> <span class="dv">4</span>)<span class="op">{</span></a>
<a class="sourceLine" id="cb1-205" title="205">    <span class="co">// evaluated if count is 4</span></a>
<a class="sourceLine" id="cb1-206" title="206"><span class="op">}</span> <span class="cf">else</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-207" title="207">    <span class="co">// evaluated if it&#39;s not either 3 or 4</span></a>
<a class="sourceLine" id="cb1-208" title="208"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-209" title="209"></a>
<a class="sourceLine" id="cb1-210" title="210"><span class="co">// As does `while`.</span></a>
<a class="sourceLine" id="cb1-211" title="211"><span class="cf">while</span> (<span class="kw">true</span>)<span class="op">{</span></a>
<a class="sourceLine" id="cb1-212" title="212">    <span class="co">// An infinite loop!</span></a>
<a class="sourceLine" id="cb1-213" title="213"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-214" title="214"></a>
<a class="sourceLine" id="cb1-215" title="215"><span class="co">// Do-while loops are like while loops, except they always run at least once.</span></a>
<a class="sourceLine" id="cb1-216" title="216"><span class="kw">var</span> input<span class="op">;</span></a>
<a class="sourceLine" id="cb1-217" title="217"><span class="cf">do</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-218" title="218">    input <span class="op">=</span> <span class="at">getInput</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb1-219" title="219"><span class="op">}</span> <span class="cf">while</span> (<span class="op">!</span><span class="at">isValid</span>(input))<span class="op">;</span></a>
<a class="sourceLine" id="cb1-220" title="220"></a>
<a class="sourceLine" id="cb1-221" title="221"><span class="co">// The `for` loop is the same as C and Java:</span></a>
<a class="sourceLine" id="cb1-222" title="222"><span class="co">// initialization; continue condition; iteration.</span></a>
<a class="sourceLine" id="cb1-223" title="223"><span class="cf">for</span> (<span class="kw">var</span> i <span class="op">=</span> <span class="dv">0</span><span class="op">;</span> i <span class="op">&lt;</span> <span class="dv">5</span><span class="op">;</span> i<span class="op">++</span>)<span class="op">{</span></a>
<a class="sourceLine" id="cb1-224" title="224">    <span class="co">// will run 5 times</span></a>
<a class="sourceLine" id="cb1-225" title="225"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-226" title="226"></a>
<a class="sourceLine" id="cb1-227" title="227"><span class="co">// Breaking out of labeled loops is similar to Java</span></a>
<a class="sourceLine" id="cb1-228" title="228">outer<span class="op">:</span></a>
<a class="sourceLine" id="cb1-229" title="229"><span class="cf">for</span> (<span class="kw">var</span> i <span class="op">=</span> <span class="dv">0</span><span class="op">;</span> i <span class="op">&lt;</span> <span class="dv">10</span><span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-230" title="230">    <span class="cf">for</span> (<span class="kw">var</span> j <span class="op">=</span> <span class="dv">0</span><span class="op">;</span> j <span class="op">&lt;</span> <span class="dv">10</span><span class="op">;</span> j<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-231" title="231">        <span class="cf">if</span> (i <span class="op">==</span> <span class="dv">5</span> <span class="op">&amp;&amp;</span> j <span class="op">==</span><span class="dv">5</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-232" title="232">            <span class="cf">break</span> outer<span class="op">;</span></a>
<a class="sourceLine" id="cb1-233" title="233">            <span class="co">// breaks out of outer loop instead of only the inner one</span></a>
<a class="sourceLine" id="cb1-234" title="234">        <span class="op">}</span></a>
<a class="sourceLine" id="cb1-235" title="235">    <span class="op">}</span></a>
<a class="sourceLine" id="cb1-236" title="236"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-237" title="237"></a>
<a class="sourceLine" id="cb1-238" title="238"><span class="co">// The for/in statement allows iteration over properties of an object.</span></a>
<a class="sourceLine" id="cb1-239" title="239"><span class="kw">var</span> description <span class="op">=</span> <span class="st">&quot;&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-240" title="240"><span class="kw">var</span> person <span class="op">=</span> <span class="op">{</span><span class="dt">fname</span><span class="op">:</span><span class="st">&quot;Paul&quot;</span><span class="op">,</span> <span class="dt">lname</span><span class="op">:</span><span class="st">&quot;Ken&quot;</span><span class="op">,</span> <span class="dt">age</span><span class="op">:</span><span class="dv">18</span><span class="op">};</span></a>
<a class="sourceLine" id="cb1-241" title="241"><span class="cf">for</span> (<span class="kw">var</span> x <span class="kw">in</span> person)<span class="op">{</span></a>
<a class="sourceLine" id="cb1-242" title="242">    description <span class="op">+=</span> person[x] <span class="op">+</span> <span class="st">&quot; &quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-243" title="243"><span class="op">}</span> <span class="co">// description = &#39;Paul Ken 18 &#39;</span></a>
<a class="sourceLine" id="cb1-244" title="244"></a>
<a class="sourceLine" id="cb1-245" title="245"><span class="co">// The for/of statement allows iteration over iterable objects (including the built-in String, </span></a>
<a class="sourceLine" id="cb1-246" title="246"><span class="co">// Array, e.g. the Array-like arguments or NodeList objects, TypedArray, Map and Set, </span></a>
<a class="sourceLine" id="cb1-247" title="247"><span class="co">// and user-defined iterables).</span></a>
<a class="sourceLine" id="cb1-248" title="248"><span class="kw">var</span> myPets <span class="op">=</span> <span class="st">&quot;&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-249" title="249"><span class="kw">var</span> pets <span class="op">=</span> [<span class="st">&quot;cat&quot;</span><span class="op">,</span> <span class="st">&quot;dog&quot;</span><span class="op">,</span> <span class="st">&quot;hamster&quot;</span><span class="op">,</span> <span class="st">&quot;hedgehog&quot;</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb1-250" title="250"><span class="cf">for</span> (<span class="kw">var</span> pet <span class="kw">of</span> pets)<span class="op">{</span></a>
<a class="sourceLine" id="cb1-251" title="251">    myPets <span class="op">+=</span> pet <span class="op">+</span> <span class="st">&quot; &quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-252" title="252"><span class="op">}</span> <span class="co">// myPets = &#39;cat dog hamster hedgehog &#39;</span></a>
<a class="sourceLine" id="cb1-253" title="253"></a>
<a class="sourceLine" id="cb1-254" title="254"><span class="co">// &amp;&amp; is logical and, || is logical or</span></a>
<a class="sourceLine" id="cb1-255" title="255"><span class="cf">if</span> (<span class="va">house</span>.<span class="at">size</span> <span class="op">==</span> <span class="st">&quot;big&quot;</span> <span class="op">&amp;&amp;</span> <span class="va">house</span>.<span class="at">colour</span> <span class="op">==</span> <span class="st">&quot;blue&quot;</span>)<span class="op">{</span></a>
<a class="sourceLine" id="cb1-256" title="256">    <span class="va">house</span>.<span class="at">contains</span> <span class="op">=</span> <span class="st">&quot;bear&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-257" title="257"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-258" title="258"><span class="cf">if</span> (colour <span class="op">==</span> <span class="st">&quot;red&quot;</span> <span class="op">||</span> colour <span class="op">==</span> <span class="st">&quot;blue&quot;</span>)<span class="op">{</span></a>
<a class="sourceLine" id="cb1-259" title="259">    <span class="co">// colour is either red or blue</span></a>
<a class="sourceLine" id="cb1-260" title="260"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-261" title="261"></a>
<a class="sourceLine" id="cb1-262" title="262"><span class="co">// &amp;&amp; and || &quot;short circuit&quot;, which is useful for setting default values.</span></a>
<a class="sourceLine" id="cb1-263" title="263"><span class="kw">var</span> name <span class="op">=</span> otherName <span class="op">||</span> <span class="st">&quot;default&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-264" title="264"></a>
<a class="sourceLine" id="cb1-265" title="265"><span class="co">// The `switch` statement checks for equality with `===`.</span></a>
<a class="sourceLine" id="cb1-266" title="266"><span class="co">// Use &#39;break&#39; after each case</span></a>
<a class="sourceLine" id="cb1-267" title="267"><span class="co">// or the cases after the correct one will be executed too.</span></a>
<a class="sourceLine" id="cb1-268" title="268">grade <span class="op">=</span> <span class="st">&#39;B&#39;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-269" title="269"><span class="cf">switch</span> (grade) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-270" title="270">  <span class="cf">case</span> <span class="st">&#39;A&#39;</span><span class="op">:</span></a>
<a class="sourceLine" id="cb1-271" title="271">    <span class="va">console</span>.<span class="at">log</span>(<span class="st">&quot;Great job&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-272" title="272">    <span class="cf">break</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-273" title="273">  <span class="cf">case</span> <span class="st">&#39;B&#39;</span><span class="op">:</span></a>
<a class="sourceLine" id="cb1-274" title="274">    <span class="va">console</span>.<span class="at">log</span>(<span class="st">&quot;OK job&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-275" title="275">    <span class="cf">break</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-276" title="276">  <span class="cf">case</span> <span class="st">&#39;C&#39;</span><span class="op">:</span></a>
<a class="sourceLine" id="cb1-277" title="277">    <span class="va">console</span>.<span class="at">log</span>(<span class="st">&quot;You can do better&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-278" title="278">    <span class="cf">break</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-279" title="279">  <span class="cf">default</span><span class="op">:</span></a>
<a class="sourceLine" id="cb1-280" title="280">    <span class="va">console</span>.<span class="at">log</span>(<span class="st">&quot;Oy vey&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-281" title="281">    <span class="cf">break</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-282" title="282"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-283" title="283"></a>
<a class="sourceLine" id="cb1-284" title="284"></a>
<a class="sourceLine" id="cb1-285" title="285"><span class="co">///////////////////////////////////</span></a>
<a class="sourceLine" id="cb1-286" title="286"><span class="co">// 4. Functions, Scope and Closures</span></a>
<a class="sourceLine" id="cb1-287" title="287"></a>
<a class="sourceLine" id="cb1-288" title="288"><span class="co">// JavaScript functions are declared with the `function` keyword.</span></a>
<a class="sourceLine" id="cb1-289" title="289"><span class="kw">function</span> <span class="at">myFunction</span>(thing)<span class="op">{</span></a>
<a class="sourceLine" id="cb1-290" title="290">    <span class="cf">return</span> <span class="va">thing</span>.<span class="at">toUpperCase</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb1-291" title="291"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-292" title="292"><span class="at">myFunction</span>(<span class="st">&quot;foo&quot;</span>)<span class="op">;</span> <span class="co">// = &quot;FOO&quot;</span></a>
<a class="sourceLine" id="cb1-293" title="293"></a>
<a class="sourceLine" id="cb1-294" title="294"><span class="co">// Note that the value to be returned must start on the same line as the</span></a>
<a class="sourceLine" id="cb1-295" title="295"><span class="co">// `return` keyword, otherwise you&#39;ll always return `undefined` due to</span></a>
<a class="sourceLine" id="cb1-296" title="296"><span class="co">// automatic semicolon insertion. Watch out for this when using Allman style.</span></a>
<a class="sourceLine" id="cb1-297" title="297"><span class="kw">function</span> <span class="at">myFunction</span>()<span class="op">{</span></a>
<a class="sourceLine" id="cb1-298" title="298">    <span class="cf">return</span> <span class="co">// &lt;- semicolon automatically inserted here</span></a>
<a class="sourceLine" id="cb1-299" title="299">    <span class="op">{</span><span class="dt">thisIsAn</span><span class="op">:</span> <span class="st">&#39;object literal&#39;</span><span class="op">};</span></a>
<a class="sourceLine" id="cb1-300" title="300"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-301" title="301"><span class="at">myFunction</span>()<span class="op">;</span> <span class="co">// = undefined</span></a>
<a class="sourceLine" id="cb1-302" title="302"></a>
<a class="sourceLine" id="cb1-303" title="303"><span class="co">// JavaScript functions are first class objects, so they can be reassigned to</span></a>
<a class="sourceLine" id="cb1-304" title="304"><span class="co">// different variable names and passed to other functions as arguments - for</span></a>
<a class="sourceLine" id="cb1-305" title="305"><span class="co">// example, when supplying an event handler:</span></a>
<a class="sourceLine" id="cb1-306" title="306"><span class="kw">function</span> <span class="at">myFunction</span>()<span class="op">{</span></a>
<a class="sourceLine" id="cb1-307" title="307">    <span class="co">// this code will be called in 5 seconds&#39; time</span></a>
<a class="sourceLine" id="cb1-308" title="308"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-309" title="309"><span class="at">setTimeout</span>(myFunction<span class="op">,</span> <span class="dv">5000</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-310" title="310"><span class="co">// Note: setTimeout isn&#39;t part of the JS language, but is provided by browsers</span></a>
<a class="sourceLine" id="cb1-311" title="311"><span class="co">// and Node.js.</span></a>
<a class="sourceLine" id="cb1-312" title="312"></a>
<a class="sourceLine" id="cb1-313" title="313"><span class="co">// Another function provided by browsers is setInterval</span></a>
<a class="sourceLine" id="cb1-314" title="314"><span class="kw">function</span> <span class="at">myFunction</span>()<span class="op">{</span></a>
<a class="sourceLine" id="cb1-315" title="315">    <span class="co">// this code will be called every 5 seconds</span></a>
<a class="sourceLine" id="cb1-316" title="316"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-317" title="317"><span class="at">setInterval</span>(myFunction<span class="op">,</span> <span class="dv">5000</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-318" title="318"></a>
<a class="sourceLine" id="cb1-319" title="319"><span class="co">// Function objects don&#39;t even have to be declared with a name - you can write</span></a>
<a class="sourceLine" id="cb1-320" title="320"><span class="co">// an anonymous function definition directly into the arguments of another.</span></a>
<a class="sourceLine" id="cb1-321" title="321"><span class="at">setTimeout</span>(<span class="kw">function</span>()<span class="op">{</span></a>
<a class="sourceLine" id="cb1-322" title="322">    <span class="co">// this code will be called in 5 seconds&#39; time</span></a>
<a class="sourceLine" id="cb1-323" title="323"><span class="op">},</span> <span class="dv">5000</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-324" title="324"></a>
<a class="sourceLine" id="cb1-325" title="325"><span class="co">// JavaScript has function scope; functions get their own scope but other blocks</span></a>
<a class="sourceLine" id="cb1-326" title="326"><span class="co">// do not.</span></a>
<a class="sourceLine" id="cb1-327" title="327"><span class="cf">if</span> (<span class="kw">true</span>)<span class="op">{</span></a>
<a class="sourceLine" id="cb1-328" title="328">    <span class="kw">var</span> i <span class="op">=</span> <span class="dv">5</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-329" title="329"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-330" title="330">i<span class="op">;</span> <span class="co">// = 5 - not undefined as you&#39;d expect in a block-scoped language</span></a>
<a class="sourceLine" id="cb1-331" title="331"></a>
<a class="sourceLine" id="cb1-332" title="332"><span class="co">// This has led to a common pattern of &quot;immediately-executing anonymous</span></a>
<a class="sourceLine" id="cb1-333" title="333"><span class="co">// functions&quot;, which prevent temporary variables from leaking into the global</span></a>
<a class="sourceLine" id="cb1-334" title="334"><span class="co">// scope.</span></a>
<a class="sourceLine" id="cb1-335" title="335">(<span class="kw">function</span>()<span class="op">{</span></a>
<a class="sourceLine" id="cb1-336" title="336">    <span class="kw">var</span> temporary <span class="op">=</span> <span class="dv">5</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-337" title="337">    <span class="co">// We can access the global scope by assigning to the &quot;global object&quot;, which</span></a>
<a class="sourceLine" id="cb1-338" title="338">    <span class="co">// in a web browser is always `window`. The global object may have a</span></a>
<a class="sourceLine" id="cb1-339" title="339">    <span class="co">// different name in non-browser environments such as Node.js.</span></a>
<a class="sourceLine" id="cb1-340" title="340">    <span class="va">window</span>.<span class="at">permanent</span> <span class="op">=</span> <span class="dv">10</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-341" title="341"><span class="op">}</span>)()<span class="op">;</span></a>
<a class="sourceLine" id="cb1-342" title="342">temporary<span class="op">;</span> <span class="co">// raises ReferenceError</span></a>
<a class="sourceLine" id="cb1-343" title="343">permanent<span class="op">;</span> <span class="co">// = 10</span></a>
<a class="sourceLine" id="cb1-344" title="344"></a>
<a class="sourceLine" id="cb1-345" title="345"><span class="co">// One of JavaScript&#39;s most powerful features is closures. If a function is</span></a>
<a class="sourceLine" id="cb1-346" title="346"><span class="co">// defined inside another function, the inner function has access to all the</span></a>
<a class="sourceLine" id="cb1-347" title="347"><span class="co">// outer function&#39;s variables, even after the outer function exits.</span></a>
<a class="sourceLine" id="cb1-348" title="348"><span class="kw">function</span> <span class="at">sayHelloInFiveSeconds</span>(name)<span class="op">{</span></a>
<a class="sourceLine" id="cb1-349" title="349">    <span class="kw">var</span> prompt <span class="op">=</span> <span class="st">&quot;Hello, &quot;</span> <span class="op">+</span> name <span class="op">+</span> <span class="st">&quot;!&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-350" title="350">    <span class="co">// Inner functions are put in the local scope by default, as if they were</span></a>
<a class="sourceLine" id="cb1-351" title="351">    <span class="co">// declared with `var`.</span></a>
<a class="sourceLine" id="cb1-352" title="352">    <span class="kw">function</span> <span class="at">inner</span>()<span class="op">{</span></a>
<a class="sourceLine" id="cb1-353" title="353">        <span class="at">alert</span>(prompt)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-354" title="354">    <span class="op">}</span></a>
<a class="sourceLine" id="cb1-355" title="355">    <span class="at">setTimeout</span>(inner<span class="op">,</span> <span class="dv">5000</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-356" title="356">    <span class="co">// setTimeout is asynchronous, so the sayHelloInFiveSeconds function will</span></a>
<a class="sourceLine" id="cb1-357" title="357">    <span class="co">// exit immediately, and setTimeout will call inner afterwards. However,</span></a>
<a class="sourceLine" id="cb1-358" title="358">    <span class="co">// because inner is &quot;closed over&quot; sayHelloInFiveSeconds, inner still has</span></a>
<a class="sourceLine" id="cb1-359" title="359">    <span class="co">// access to the `prompt` variable when it is finally called.</span></a>
<a class="sourceLine" id="cb1-360" title="360"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-361" title="361"><span class="at">sayHelloInFiveSeconds</span>(<span class="st">&quot;Adam&quot;</span>)<span class="op">;</span> <span class="co">// will open a popup with &quot;Hello, Adam!&quot; in 5s</span></a>
<a class="sourceLine" id="cb1-362" title="362"></a>
<a class="sourceLine" id="cb1-363" title="363"><span class="co">///////////////////////////////////</span></a>
<a class="sourceLine" id="cb1-364" title="364"><span class="co">// 5. More about Objects; Constructors and Prototypes</span></a>
<a class="sourceLine" id="cb1-365" title="365"></a>
<a class="sourceLine" id="cb1-366" title="366"><span class="co">// Objects can contain functions.</span></a>
<a class="sourceLine" id="cb1-367" title="367"><span class="kw">var</span> myObj <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-368" title="368">    <span class="dt">myFunc</span><span class="op">:</span> <span class="kw">function</span>()<span class="op">{</span></a>
<a class="sourceLine" id="cb1-369" title="369">        <span class="cf">return</span> <span class="st">&quot;Hello world!&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-370" title="370">    <span class="op">}</span></a>
<a class="sourceLine" id="cb1-371" title="371"><span class="op">};</span></a>
<a class="sourceLine" id="cb1-372" title="372"><span class="va">myObj</span>.<span class="at">myFunc</span>()<span class="op">;</span> <span class="co">// = &quot;Hello world!&quot;</span></a>
<a class="sourceLine" id="cb1-373" title="373"></a>
<a class="sourceLine" id="cb1-374" title="374"><span class="co">// When functions attached to an object are called, they can access the object</span></a>
<a class="sourceLine" id="cb1-375" title="375"><span class="co">// they&#39;re attached to using the `this` keyword.</span></a>
<a class="sourceLine" id="cb1-376" title="376">myObj <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-377" title="377">    <span class="dt">myString</span><span class="op">:</span> <span class="st">&quot;Hello world!&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-378" title="378">    <span class="dt">myFunc</span><span class="op">:</span> <span class="kw">function</span>()<span class="op">{</span></a>
<a class="sourceLine" id="cb1-379" title="379">        <span class="cf">return</span> <span class="kw">this</span>.<span class="at">myString</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-380" title="380">    <span class="op">}</span></a>
<a class="sourceLine" id="cb1-381" title="381"><span class="op">};</span></a>
<a class="sourceLine" id="cb1-382" title="382"><span class="va">myObj</span>.<span class="at">myFunc</span>()<span class="op">;</span> <span class="co">// = &quot;Hello world!&quot;</span></a>
<a class="sourceLine" id="cb1-383" title="383"></a>
<a class="sourceLine" id="cb1-384" title="384"><span class="co">// What this is set to has to do with how the function is called, not where</span></a>
<a class="sourceLine" id="cb1-385" title="385"><span class="co">// it&#39;s defined. So, our function doesn&#39;t work if it isn&#39;t called in the</span></a>
<a class="sourceLine" id="cb1-386" title="386"><span class="co">// context of the object.</span></a>
<a class="sourceLine" id="cb1-387" title="387"><span class="kw">var</span> myFunc <span class="op">=</span> <span class="va">myObj</span>.<span class="at">myFunc</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-388" title="388"><span class="at">myFunc</span>()<span class="op">;</span> <span class="co">// = undefined</span></a>
<a class="sourceLine" id="cb1-389" title="389"></a>
<a class="sourceLine" id="cb1-390" title="390"><span class="co">// Inversely, a function can be assigned to the object and gain access to it</span></a>
<a class="sourceLine" id="cb1-391" title="391"><span class="co">// through `this`, even if it wasn&#39;t attached when it was defined.</span></a>
<a class="sourceLine" id="cb1-392" title="392"><span class="kw">var</span> myOtherFunc <span class="op">=</span> <span class="kw">function</span>()<span class="op">{</span></a>
<a class="sourceLine" id="cb1-393" title="393">    <span class="cf">return</span> <span class="kw">this</span>.<span class="va">myString</span>.<span class="at">toUpperCase</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb1-394" title="394"><span class="op">};</span></a>
<a class="sourceLine" id="cb1-395" title="395"><span class="va">myObj</span>.<span class="at">myOtherFunc</span> <span class="op">=</span> myOtherFunc<span class="op">;</span></a>
<a class="sourceLine" id="cb1-396" title="396"><span class="va">myObj</span>.<span class="at">myOtherFunc</span>()<span class="op">;</span> <span class="co">// = &quot;HELLO WORLD!&quot;</span></a>
<a class="sourceLine" id="cb1-397" title="397"></a>
<a class="sourceLine" id="cb1-398" title="398"><span class="co">// We can also specify a context for a function to execute in when we invoke it</span></a>
<a class="sourceLine" id="cb1-399" title="399"><span class="co">// using `call` or `apply`.</span></a>
<a class="sourceLine" id="cb1-400" title="400"></a>
<a class="sourceLine" id="cb1-401" title="401"><span class="kw">var</span> anotherFunc <span class="op">=</span> <span class="kw">function</span>(s)<span class="op">{</span></a>
<a class="sourceLine" id="cb1-402" title="402">    <span class="cf">return</span> <span class="kw">this</span>.<span class="at">myString</span> <span class="op">+</span> s<span class="op">;</span></a>
<a class="sourceLine" id="cb1-403" title="403"><span class="op">};</span></a>
<a class="sourceLine" id="cb1-404" title="404"><span class="va">anotherFunc</span>.<span class="at">call</span>(myObj<span class="op">,</span> <span class="st">&quot; And Hello Moon!&quot;</span>)<span class="op">;</span> <span class="co">// = &quot;Hello World! And Hello Moon!&quot;</span></a>
<a class="sourceLine" id="cb1-405" title="405"></a>
<a class="sourceLine" id="cb1-406" title="406"><span class="co">// The `apply` function is nearly identical, but takes an array for an argument</span></a>
<a class="sourceLine" id="cb1-407" title="407"><span class="co">// list.</span></a>
<a class="sourceLine" id="cb1-408" title="408"></a>
<a class="sourceLine" id="cb1-409" title="409"><span class="va">anotherFunc</span>.<span class="at">apply</span>(myObj<span class="op">,</span> [<span class="st">&quot; And Hello Sun!&quot;</span>])<span class="op">;</span> <span class="co">// = &quot;Hello World! And Hello Sun!&quot;</span></a>
<a class="sourceLine" id="cb1-410" title="410"></a>
<a class="sourceLine" id="cb1-411" title="411"><span class="co">// This is useful when working with a function that accepts a sequence of</span></a>
<a class="sourceLine" id="cb1-412" title="412"><span class="co">// arguments and you want to pass an array.</span></a>
<a class="sourceLine" id="cb1-413" title="413"></a>
<a class="sourceLine" id="cb1-414" title="414"><span class="va">Math</span>.<span class="at">min</span>(<span class="dv">42</span><span class="op">,</span> <span class="dv">6</span><span class="op">,</span> <span class="dv">27</span>)<span class="op">;</span> <span class="co">// = 6</span></a>
<a class="sourceLine" id="cb1-415" title="415"><span class="va">Math</span>.<span class="at">min</span>([<span class="dv">42</span><span class="op">,</span> <span class="dv">6</span><span class="op">,</span> <span class="dv">27</span>])<span class="op">;</span> <span class="co">// = NaN (uh-oh!)</span></a>
<a class="sourceLine" id="cb1-416" title="416"><span class="va">Math</span>.<span class="va">min</span>.<span class="at">apply</span>(Math<span class="op">,</span> [<span class="dv">42</span><span class="op">,</span> <span class="dv">6</span><span class="op">,</span> <span class="dv">27</span>])<span class="op">;</span> <span class="co">// = 6</span></a>
<a class="sourceLine" id="cb1-417" title="417"></a>
<a class="sourceLine" id="cb1-418" title="418"><span class="co">// But, `call` and `apply` are only temporary. When we want it to stick, we can</span></a>
<a class="sourceLine" id="cb1-419" title="419"><span class="co">// use `bind`.</span></a>
<a class="sourceLine" id="cb1-420" title="420"></a>
<a class="sourceLine" id="cb1-421" title="421"><span class="kw">var</span> boundFunc <span class="op">=</span> <span class="va">anotherFunc</span>.<span class="at">bind</span>(myObj)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-422" title="422"><span class="at">boundFunc</span>(<span class="st">&quot; And Hello Saturn!&quot;</span>)<span class="op">;</span> <span class="co">// = &quot;Hello World! And Hello Saturn!&quot;</span></a>
<a class="sourceLine" id="cb1-423" title="423"></a>
<a class="sourceLine" id="cb1-424" title="424"><span class="co">// `bind` can also be used to partially apply (curry) a function.</span></a>
<a class="sourceLine" id="cb1-425" title="425"></a>
<a class="sourceLine" id="cb1-426" title="426"><span class="kw">var</span> product <span class="op">=</span> <span class="kw">function</span>(a<span class="op">,</span> b)<span class="op">{</span> <span class="cf">return</span> a <span class="op">*</span> b<span class="op">;</span> <span class="op">};</span></a>
<a class="sourceLine" id="cb1-427" title="427"><span class="kw">var</span> doubler <span class="op">=</span> <span class="va">product</span>.<span class="at">bind</span>(<span class="kw">this</span><span class="op">,</span> <span class="dv">2</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-428" title="428"><span class="at">doubler</span>(<span class="dv">8</span>)<span class="op">;</span> <span class="co">// = 16</span></a>
<a class="sourceLine" id="cb1-429" title="429"></a>
<a class="sourceLine" id="cb1-430" title="430"><span class="co">// When you call a function with the `new` keyword, a new object is created, and</span></a>
<a class="sourceLine" id="cb1-431" title="431"><span class="co">// made available to the function via the `this` keyword. Functions designed to be</span></a>
<a class="sourceLine" id="cb1-432" title="432"><span class="co">// called like that are called constructors.</span></a>
<a class="sourceLine" id="cb1-433" title="433"></a>
<a class="sourceLine" id="cb1-434" title="434"><span class="kw">var</span> MyConstructor <span class="op">=</span> <span class="kw">function</span>()<span class="op">{</span></a>
<a class="sourceLine" id="cb1-435" title="435">    <span class="kw">this</span>.<span class="at">myNumber</span> <span class="op">=</span> <span class="dv">5</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-436" title="436"><span class="op">};</span></a>
<a class="sourceLine" id="cb1-437" title="437">myNewObj <span class="op">=</span> <span class="kw">new</span> <span class="at">MyConstructor</span>()<span class="op">;</span> <span class="co">// = {myNumber: 5}</span></a>
<a class="sourceLine" id="cb1-438" title="438"><span class="va">myNewObj</span>.<span class="at">myNumber</span><span class="op">;</span> <span class="co">// = 5</span></a>
<a class="sourceLine" id="cb1-439" title="439"></a>
<a class="sourceLine" id="cb1-440" title="440"><span class="co">// Unlike most other popular object-oriented languages, JavaScript has no</span></a>
<a class="sourceLine" id="cb1-441" title="441"><span class="co">// concept of &#39;instances&#39; created from &#39;class&#39; blueprints; instead, JavaScript</span></a>
<a class="sourceLine" id="cb1-442" title="442"><span class="co">// combines instantiation and inheritance into a single concept: a &#39;prototype&#39;.</span></a>
<a class="sourceLine" id="cb1-443" title="443"></a>
<a class="sourceLine" id="cb1-444" title="444"><span class="co">// Every JavaScript object has a &#39;prototype&#39;. When you go to access a property</span></a>
<a class="sourceLine" id="cb1-445" title="445"><span class="co">// on an object that doesn&#39;t exist on the actual object, the interpreter will</span></a>
<a class="sourceLine" id="cb1-446" title="446"><span class="co">// look at its prototype.</span></a>
<a class="sourceLine" id="cb1-447" title="447"></a>
<a class="sourceLine" id="cb1-448" title="448"><span class="co">// Some JS implementations let you access an object&#39;s prototype on the magic</span></a>
<a class="sourceLine" id="cb1-449" title="449"><span class="co">// property `__proto__`. While this is useful for explaining prototypes it&#39;s not</span></a>
<a class="sourceLine" id="cb1-450" title="450"><span class="co">// part of the standard; we&#39;ll get to standard ways of using prototypes later.</span></a>
<a class="sourceLine" id="cb1-451" title="451"><span class="kw">var</span> myObj <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-452" title="452">    <span class="dt">myString</span><span class="op">:</span> <span class="st">&quot;Hello world!&quot;</span></a>
<a class="sourceLine" id="cb1-453" title="453"><span class="op">};</span></a>
<a class="sourceLine" id="cb1-454" title="454"><span class="kw">var</span> myPrototype <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-455" title="455">    <span class="dt">meaningOfLife</span><span class="op">:</span> <span class="dv">42</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-456" title="456">    <span class="dt">myFunc</span><span class="op">:</span> <span class="kw">function</span>()<span class="op">{</span></a>
<a class="sourceLine" id="cb1-457" title="457">        <span class="cf">return</span> <span class="kw">this</span>.<span class="va">myString</span>.<span class="at">toLowerCase</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb1-458" title="458">    <span class="op">}</span></a>
<a class="sourceLine" id="cb1-459" title="459"><span class="op">};</span></a>
<a class="sourceLine" id="cb1-460" title="460"></a>
<a class="sourceLine" id="cb1-461" title="461"><span class="va">myObj</span>.<span class="at">__proto__</span> <span class="op">=</span> myPrototype<span class="op">;</span></a>
<a class="sourceLine" id="cb1-462" title="462"><span class="va">myObj</span>.<span class="at">meaningOfLife</span><span class="op">;</span> <span class="co">// = 42</span></a>
<a class="sourceLine" id="cb1-463" title="463"></a>
<a class="sourceLine" id="cb1-464" title="464"><span class="co">// This works for functions, too.</span></a>
<a class="sourceLine" id="cb1-465" title="465"><span class="va">myObj</span>.<span class="at">myFunc</span>()<span class="op">;</span> <span class="co">// = &quot;hello world!&quot;</span></a>
<a class="sourceLine" id="cb1-466" title="466"></a>
<a class="sourceLine" id="cb1-467" title="467"><span class="co">// Of course, if your property isn&#39;t on your prototype, the prototype&#39;s</span></a>
<a class="sourceLine" id="cb1-468" title="468"><span class="co">// prototype is searched, and so on.</span></a>
<a class="sourceLine" id="cb1-469" title="469"><span class="va">myPrototype</span>.<span class="at">__proto__</span> <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-470" title="470">    <span class="dt">myBoolean</span><span class="op">:</span> <span class="kw">true</span></a>
<a class="sourceLine" id="cb1-471" title="471"><span class="op">};</span></a>
<a class="sourceLine" id="cb1-472" title="472"><span class="va">myObj</span>.<span class="at">myBoolean</span><span class="op">;</span> <span class="co">// = true</span></a>
<a class="sourceLine" id="cb1-473" title="473"></a>
<a class="sourceLine" id="cb1-474" title="474"><span class="co">// There&#39;s no copying involved here; each object stores a reference to its</span></a>
<a class="sourceLine" id="cb1-475" title="475"><span class="co">// prototype. This means we can alter the prototype and our changes will be</span></a>
<a class="sourceLine" id="cb1-476" title="476"><span class="co">// reflected everywhere.</span></a>
<a class="sourceLine" id="cb1-477" title="477"><span class="va">myPrototype</span>.<span class="at">meaningOfLife</span> <span class="op">=</span> <span class="dv">43</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-478" title="478"><span class="va">myObj</span>.<span class="at">meaningOfLife</span><span class="op">;</span> <span class="co">// = 43</span></a>
<a class="sourceLine" id="cb1-479" title="479"></a>
<a class="sourceLine" id="cb1-480" title="480"><span class="co">// The for/in statement allows iteration over properties of an object,</span></a>
<a class="sourceLine" id="cb1-481" title="481"><span class="co">// walking up the prototype chain until it sees a null prototype.</span></a>
<a class="sourceLine" id="cb1-482" title="482"><span class="cf">for</span> (<span class="kw">var</span> x <span class="kw">in</span> myObj)<span class="op">{</span></a>
<a class="sourceLine" id="cb1-483" title="483">    <span class="va">console</span>.<span class="at">log</span>(myObj[x])<span class="op">;</span></a>
<a class="sourceLine" id="cb1-484" title="484"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-485" title="485"><span class="co">///prints:</span></a>
<a class="sourceLine" id="cb1-486" title="486"><span class="co">// Hello world!</span></a>
<a class="sourceLine" id="cb1-487" title="487"><span class="co">// 43</span></a>
<a class="sourceLine" id="cb1-488" title="488"><span class="co">// [Function: myFunc]</span></a>
<a class="sourceLine" id="cb1-489" title="489"><span class="co">// true</span></a>
<a class="sourceLine" id="cb1-490" title="490"></a>
<a class="sourceLine" id="cb1-491" title="491"><span class="co">// To only consider properties attached to the object itself</span></a>
<a class="sourceLine" id="cb1-492" title="492"><span class="co">// and not its prototypes, use the `hasOwnProperty()` check.</span></a>
<a class="sourceLine" id="cb1-493" title="493"><span class="cf">for</span> (<span class="kw">var</span> x <span class="kw">in</span> myObj)<span class="op">{</span></a>
<a class="sourceLine" id="cb1-494" title="494">    <span class="cf">if</span> (<span class="va">myObj</span>.<span class="at">hasOwnProperty</span>(x))<span class="op">{</span></a>
<a class="sourceLine" id="cb1-495" title="495">        <span class="va">console</span>.<span class="at">log</span>(myObj[x])<span class="op">;</span></a>
<a class="sourceLine" id="cb1-496" title="496">    <span class="op">}</span></a>
<a class="sourceLine" id="cb1-497" title="497"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-498" title="498"><span class="co">///prints:</span></a>
<a class="sourceLine" id="cb1-499" title="499"><span class="co">// Hello world!</span></a>
<a class="sourceLine" id="cb1-500" title="500"></a>
<a class="sourceLine" id="cb1-501" title="501"><span class="co">// We mentioned that `__proto__` was non-standard, and there&#39;s no standard way to</span></a>
<a class="sourceLine" id="cb1-502" title="502"><span class="co">// change the prototype of an existing object. However, there are two ways to</span></a>
<a class="sourceLine" id="cb1-503" title="503"><span class="co">// create a new object with a given prototype.</span></a>
<a class="sourceLine" id="cb1-504" title="504"></a>
<a class="sourceLine" id="cb1-505" title="505"><span class="co">// The first is Object.create, which is a recent addition to JS, and therefore</span></a>
<a class="sourceLine" id="cb1-506" title="506"><span class="co">// not available in all implementations yet.</span></a>
<a class="sourceLine" id="cb1-507" title="507"><span class="kw">var</span> myObj <span class="op">=</span> <span class="va">Object</span>.<span class="at">create</span>(myPrototype)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-508" title="508"><span class="va">myObj</span>.<span class="at">meaningOfLife</span><span class="op">;</span> <span class="co">// = 43</span></a>
<a class="sourceLine" id="cb1-509" title="509"></a>
<a class="sourceLine" id="cb1-510" title="510"><span class="co">// The second way, which works anywhere, has to do with constructors.</span></a>
<a class="sourceLine" id="cb1-511" title="511"><span class="co">// Constructors have a property called prototype. This is *not* the prototype of</span></a>
<a class="sourceLine" id="cb1-512" title="512"><span class="co">// the constructor function itself; instead, it&#39;s the prototype that new objects</span></a>
<a class="sourceLine" id="cb1-513" title="513"><span class="co">// are given when they&#39;re created with that constructor and the new keyword.</span></a>
<a class="sourceLine" id="cb1-514" title="514"><span class="va">MyConstructor</span>.<span class="at">prototype</span> <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-515" title="515">    <span class="dt">myNumber</span><span class="op">:</span> <span class="dv">5</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-516" title="516">    <span class="dt">getMyNumber</span><span class="op">:</span> <span class="kw">function</span>()<span class="op">{</span></a>
<a class="sourceLine" id="cb1-517" title="517">        <span class="cf">return</span> <span class="kw">this</span>.<span class="at">myNumber</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-518" title="518">    <span class="op">}</span></a>
<a class="sourceLine" id="cb1-519" title="519"><span class="op">};</span></a>
<a class="sourceLine" id="cb1-520" title="520"><span class="kw">var</span> myNewObj2 <span class="op">=</span> <span class="kw">new</span> <span class="at">MyConstructor</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb1-521" title="521"><span class="va">myNewObj2</span>.<span class="at">getMyNumber</span>()<span class="op">;</span> <span class="co">// = 5</span></a>
<a class="sourceLine" id="cb1-522" title="522"><span class="va">myNewObj2</span>.<span class="at">myNumber</span> <span class="op">=</span> <span class="dv">6</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-523" title="523"><span class="va">myNewObj2</span>.<span class="at">getMyNumber</span>()<span class="op">;</span> <span class="co">// = 6</span></a>
<a class="sourceLine" id="cb1-524" title="524"></a>
<a class="sourceLine" id="cb1-525" title="525"><span class="co">// Built-in types like strings and numbers also have constructors that create</span></a>
<a class="sourceLine" id="cb1-526" title="526"><span class="co">// equivalent wrapper objects.</span></a>
<a class="sourceLine" id="cb1-527" title="527"><span class="kw">var</span> myNumber <span class="op">=</span> <span class="dv">12</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-528" title="528"><span class="kw">var</span> myNumberObj <span class="op">=</span> <span class="kw">new</span> <span class="at">Number</span>(<span class="dv">12</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-529" title="529">myNumber <span class="op">==</span> myNumberObj<span class="op">;</span> <span class="co">// = true</span></a>
<a class="sourceLine" id="cb1-530" title="530"></a>
<a class="sourceLine" id="cb1-531" title="531"><span class="co">// Except, they aren&#39;t exactly equivalent.</span></a>
<a class="sourceLine" id="cb1-532" title="532"><span class="kw">typeof</span> myNumber<span class="op">;</span> <span class="co">// = &#39;number&#39;</span></a>
<a class="sourceLine" id="cb1-533" title="533"><span class="kw">typeof</span> myNumberObj<span class="op">;</span> <span class="co">// = &#39;object&#39;</span></a>
<a class="sourceLine" id="cb1-534" title="534">myNumber <span class="op">===</span> myNumberObj<span class="op">;</span> <span class="co">// = false</span></a>
<a class="sourceLine" id="cb1-535" title="535"><span class="cf">if</span> (<span class="dv">0</span>)<span class="op">{</span></a>
<a class="sourceLine" id="cb1-536" title="536">    <span class="co">// This code won&#39;t execute, because 0 is falsy.</span></a>
<a class="sourceLine" id="cb1-537" title="537"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-538" title="538"><span class="cf">if</span> (<span class="kw">new</span> <span class="at">Number</span>(<span class="dv">0</span>))<span class="op">{</span></a>
<a class="sourceLine" id="cb1-539" title="539">   <span class="co">// This code will execute, because wrapped numbers are objects, and objects</span></a>
<a class="sourceLine" id="cb1-540" title="540">   <span class="co">// are always truthy.</span></a>
<a class="sourceLine" id="cb1-541" title="541"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-542" title="542"></a>
<a class="sourceLine" id="cb1-543" title="543"><span class="co">// However, the wrapper objects and the regular builtins share a prototype, so</span></a>
<a class="sourceLine" id="cb1-544" title="544"><span class="co">// you can actually add functionality to a string, for instance.</span></a>
<a class="sourceLine" id="cb1-545" title="545"><span class="va">String</span>.<span class="va">prototype</span>.<span class="at">firstCharacter</span> <span class="op">=</span> <span class="kw">function</span>()<span class="op">{</span></a>
<a class="sourceLine" id="cb1-546" title="546">    <span class="cf">return</span> <span class="kw">this</span>.<span class="at">charAt</span>(<span class="dv">0</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-547" title="547"><span class="op">};</span></a>
<a class="sourceLine" id="cb1-548" title="548"><span class="st">&quot;abc&quot;</span>.<span class="at">firstCharacter</span>()<span class="op">;</span> <span class="co">// = &quot;a&quot;</span></a>
<a class="sourceLine" id="cb1-549" title="549"></a>
<a class="sourceLine" id="cb1-550" title="550"><span class="co">// This fact is often used in &quot;polyfilling&quot;, which is implementing newer</span></a>
<a class="sourceLine" id="cb1-551" title="551"><span class="co">// features of JavaScript in an older subset of JavaScript, so that they can be</span></a>
<a class="sourceLine" id="cb1-552" title="552"><span class="co">// used in older environments such as outdated browsers.</span></a>
<a class="sourceLine" id="cb1-553" title="553"></a>
<a class="sourceLine" id="cb1-554" title="554"><span class="co">// For instance, we mentioned that Object.create isn&#39;t yet available in all</span></a>
<a class="sourceLine" id="cb1-555" title="555"><span class="co">// implementations, but we can still use it with this polyfill:</span></a>
<a class="sourceLine" id="cb1-556" title="556"><span class="cf">if</span> (<span class="va">Object</span>.<span class="at">create</span> <span class="op">===</span> <span class="kw">undefined</span>)<span class="op">{</span> <span class="co">// don&#39;t overwrite it if it exists</span></a>
<a class="sourceLine" id="cb1-557" title="557">    <span class="va">Object</span>.<span class="at">create</span> <span class="op">=</span> <span class="kw">function</span>(proto)<span class="op">{</span></a>
<a class="sourceLine" id="cb1-558" title="558">        <span class="co">// make a temporary constructor with the right prototype</span></a>
<a class="sourceLine" id="cb1-559" title="559">        <span class="kw">var</span> Constructor <span class="op">=</span> <span class="kw">function</span>()<span class="op">{};</span></a>
<a class="sourceLine" id="cb1-560" title="560">        <span class="va">Constructor</span>.<span class="at">prototype</span> <span class="op">=</span> proto<span class="op">;</span></a>
<a class="sourceLine" id="cb1-561" title="561">        <span class="co">// then use it to create a new, appropriately-prototyped object</span></a>
<a class="sourceLine" id="cb1-562" title="562">        <span class="cf">return</span> <span class="kw">new</span> <span class="at">Constructor</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb1-563" title="563">    <span class="op">};</span></a>
<a class="sourceLine" id="cb1-564" title="564"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-565" title="565"></a>
<a class="sourceLine" id="cb1-566" title="566"><span class="co">// ES6 Additions</span></a>
<a class="sourceLine" id="cb1-567" title="567"></a>
<a class="sourceLine" id="cb1-568" title="568"><span class="co">// The &quot;let&quot; keyword allows you to define variables in a lexical scope, </span></a>
<a class="sourceLine" id="cb1-569" title="569"><span class="co">// as opposed to a block scope like the var keyword does.</span></a>
<a class="sourceLine" id="cb1-570" title="570"><span class="kw">let</span> name <span class="op">=</span> <span class="st">&quot;Billy&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-571" title="571"></a>
<a class="sourceLine" id="cb1-572" title="572"><span class="co">// Variables defined with let can be reassigned new values.</span></a>
<a class="sourceLine" id="cb1-573" title="573">name <span class="op">=</span> <span class="st">&quot;William&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-574" title="574"></a>
<a class="sourceLine" id="cb1-575" title="575"><span class="co">// The &quot;const&quot; keyword allows you to define a variable in a lexical scope</span></a>
<a class="sourceLine" id="cb1-576" title="576"><span class="co">// like with let, but you cannot reassign the value once one has been assigned.</span></a>
<a class="sourceLine" id="cb1-577" title="577"></a>
<a class="sourceLine" id="cb1-578" title="578"><span class="kw">const</span> pi <span class="op">=</span> <span class="fl">3.14</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-579" title="579"></a>
<a class="sourceLine" id="cb1-580" title="580">pi <span class="op">=</span> <span class="fl">4.13</span><span class="op">;</span> <span class="co">// You cannot do this.</span></a>
<a class="sourceLine" id="cb1-581" title="581"></a>
<a class="sourceLine" id="cb1-582" title="582"><span class="co">// There is a new syntax for functions in ES6 known as &quot;lambda syntax&quot;.</span></a>
<a class="sourceLine" id="cb1-583" title="583"><span class="co">// This allows functions to be defined in a lexical scope like with variables</span></a>
<a class="sourceLine" id="cb1-584" title="584"><span class="co">// defined by const and let. </span></a>
<a class="sourceLine" id="cb1-585" title="585"></a>
<a class="sourceLine" id="cb1-586" title="586"><span class="kw">const</span> isEven <span class="op">=</span> (number) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-587" title="587">    <span class="cf">return</span> number <span class="op">%</span> <span class="dv">2</span> <span class="op">===</span> <span class="dv">0</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-588" title="588"><span class="op">};</span></a>
<a class="sourceLine" id="cb1-589" title="589"></a>
<a class="sourceLine" id="cb1-590" title="590"><span class="at">isEven</span>(<span class="dv">7</span>)<span class="op">;</span> <span class="co">// false</span></a>
<a class="sourceLine" id="cb1-591" title="591"></a>
<a class="sourceLine" id="cb1-592" title="592"><span class="co">// The &quot;equivalent&quot; of this function in the traditional syntax would look like this:</span></a>
<a class="sourceLine" id="cb1-593" title="593"></a>
<a class="sourceLine" id="cb1-594" title="594"><span class="kw">function</span> <span class="at">isEven</span>(number) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-595" title="595">    <span class="cf">return</span> number <span class="op">%</span> <span class="dv">2</span> <span class="op">===</span> <span class="dv">0</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-596" title="596"><span class="op">};</span></a>
<a class="sourceLine" id="cb1-597" title="597"></a>
<a class="sourceLine" id="cb1-598" title="598"><span class="co">// I put the word &quot;equivalent&quot; in double quotes because a function defined</span></a>
<a class="sourceLine" id="cb1-599" title="599"><span class="co">// using the lambda syntax cannnot be called before the definition.</span></a>
<a class="sourceLine" id="cb1-600" title="600"><span class="co">// The following is an example of invalid usage:</span></a>
<a class="sourceLine" id="cb1-601" title="601"></a>
<a class="sourceLine" id="cb1-602" title="602"><span class="at">add</span>(<span class="dv">1</span><span class="op">,</span> <span class="dv">8</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-603" title="603"></a>
<a class="sourceLine" id="cb1-604" title="604"><span class="kw">const</span> add <span class="op">=</span> (firstNumber<span class="op">,</span> secondNumber) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-605" title="605">    <span class="cf">return</span> firstNumber <span class="op">+</span> secondNumber<span class="op">;</span></a>
<a class="sourceLine" id="cb1-606" title="606"><span class="op">};</span></a></code></pre>
    </div>
    <h2 id="further-reading">Further Reading</h2>
    <p>
      The
      <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript"
        >Mozilla Developer Network</a
      >
      provides excellent documentation for JavaScript as it’s used in browsers.
      Plus, it’s a wiki, so as you learn more you can help others out by sharing
      your own knowledge.
    </p>
    <p>
      MDN’s
      <a
        href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/A_re-introduction_to_JavaScript"
        >A re-introduction to JavaScript</a
      >
      covers much of the concepts covered here in more detail. This guide has
      quite deliberately only covered the JavaScript language itself; if you
      want to learn more about how to use JavaScript in web pages, start by
      learning about the
      <a
        href="https://developer.mozilla.org/en-US/docs/Using_the_W3C_DOM_Level_1_Core"
        >Document Object Model</a
      >.
    </p>
    <p>
      <a href="http://www.learneroo.com/modules/64/nodes/350"
        >Learn Javascript by Example and with Challenges</a
      >
      is a variant of this reference with built-in challenges.
    </p>
    <p>
      <a href="http://bonsaiden.github.io/JavaScript-Garden/"
        >JavaScript Garden</a
      >
      is an in-depth guide of all the counter-intuitive parts of the language.
    </p>
    <p>
      <a href="http://www.amazon.com/gp/product/0596805527/"
        >JavaScript: The Definitive Guide</a
      >
      is a classic guide and reference book.
    </p>
    <p>
      <a href="http://eloquentjavascript.net/">Eloquent Javascript</a> by Marijn
      Haverbeke is an excellent JS book/ebook with attached terminal
    </p>
    <p>
      <a href="http://jstherightway.org/">Javascript: The Right Way</a> is a
      guide intended to introduce new developers to JavaScript and help
      experienced developers learn more about its best practices.
    </p>
    <p>
      <a href="https://javascript.info/">Javascript:Info</a> is a modern
      javascript tutorial covering the basics (core language and working with a
      browser) as well as advanced topics with concise explanations.
    </p>
    <p>
      In addition to direct contributors to this article, some content is
      adapted from Louie Dinh’s Python tutorial on this site, and the
      <a
        href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/A_re-introduction_to_JavaScript"
        >JS Tutorial</a
      >
      on the Mozilla Developer Network.
    </p>
  </body>
</html>
